/********************************************/
/* Automatic export to RED -- DO NOT MODIFY */
/********************************************/

process count = 6;
global clock timer, x0, x1, x2, x3, x4;
global discrete inToken_0 : 0..4;
global discrete inToken_1 : 0..4;
global discrete inToken_2 : 0..4;
global discrete inToken_3 : 0..4;
global discrete inToken_4 : 0..4;
global discrete outToken_0 : 0..4;
global discrete outToken_1 : 0..4;
global discrete outToken_2 : 0..4;
global discrete outToken_3 : 0..4;
global discrete outToken_4 : 0..4;
global synchronizer finished_0, finished_1, finished_2, finished_3, finished_4, release_lock_0, release_lock_1, release_lock_2, release_lock_3, release_lock_4, set_lock_0, set_lock_1, set_lock_2, set_lock_3, set_lock_4;

/****** COMPONENT: Stopwatch *****/
mode Stopwatch_Wait_for_Leader (true) {
	when !finished_0 ((timer<=4) && (true)) may goto Stopwatch_Safety;
	when !finished_1 ((timer<=4) && (true)) may goto Stopwatch_Safety;
	when !finished_2 ((timer<=4) && (true)) may goto Stopwatch_Safety;
	when !finished_3 ((timer<=4) && (true)) may goto Stopwatch_Safety;
	when !finished_4 ((timer<=4) && (true)) may goto Stopwatch_Safety;
	when ((timer>4) && (true)) may goto Stopwatch_Timeout;
}

mode Stopwatch_Safety (true) {
}

mode Stopwatch_Timeout (true) {
}


/****** COMPONENT: Candidate_0 *****/
mode Candidate_0_Init (x0<=0) {
	when !set_lock_4 ((true) && (true)) may x0 = 0; goto Candidate_0_Read_inToken;
	when !set_lock_0 ((true) && (true)) may x1 = 0; goto Candidate_0_Wait_till_succ_read_outToken;
}

mode Candidate_0_Wait_for_pre (x0<=0) {
	when !set_lock_4 ((true) && (true)) may x0 = 0; goto Candidate_0_Read_inToken;
}

mode Candidate_0_Read_inToken (x0<=1) {
	when ((true) && (true)) may inToken_0=outToken_4; goto Candidate_0_Release_in_lock;
}

mode Candidate_0_Release_in_lock (x0<=1) {
	when !release_lock_4 ((true) && (true)) may x4 = 0; goto Candidate_0_Eval_inToken;
}

mode Candidate_0_Eval_inToken (x0<=1) {
	when ?finished_0 ((true) && (inToken_0==0)) may goto Candidate_0_Leader;
	when ((true) && (inToken_0==1)) may outToken_0=inToken_0; goto Candidate_0_Wait_for_succ;
	when ((true) && (inToken_0==2)) may outToken_0=inToken_0; goto Candidate_0_Wait_for_succ;
	when ((true) && (inToken_0==3)) may outToken_0=inToken_0; goto Candidate_0_Wait_for_succ;
	when ((true) && (inToken_0==4)) may outToken_0=inToken_0; goto Candidate_0_Wait_for_succ;
}

mode Candidate_0_Wait_for_succ (true) {
	when !set_lock_0 ((true) && (true)) may x1 = 0; goto Candidate_0_Wait_till_succ_read_outToken;
}

mode Candidate_0_Wait_till_succ_read_outToken (true) {
	when !release_lock_0 ((true) && (true)) may x0 = 0; goto Candidate_0_Wait_for_pre;
}

mode Candidate_0_Leader (true) {
}


/****** COMPONENT: Candidate_1 *****/
mode Candidate_1_Init (x1<=0) {
	when ?set_lock_0 ((true) && (true)) may x1 = 0; goto Candidate_1_Read_inToken;
	when !set_lock_1 ((true) && (true)) may x2 = 0; goto Candidate_1_Wait_till_succ_read_outToken;
}

mode Candidate_1_Wait_for_pre (x1<=0) {
	when ?set_lock_0 ((true) && (true)) may x1 = 0; goto Candidate_1_Read_inToken;
}

mode Candidate_1_Read_inToken (x1<=1) {
	when ((true) && (true)) may inToken_1=outToken_0; goto Candidate_1_Release_in_lock;
}

mode Candidate_1_Release_in_lock (x1<=1) {
	when ?release_lock_0 ((true) && (true)) may x0 = 0; goto Candidate_1_Eval_inToken;
}

mode Candidate_1_Eval_inToken (x1<=1) {
	when ?finished_1 ((true) && (inToken_1==1)) may goto Candidate_1_Leader;
	when ((true) && (inToken_1==0)) may goto Candidate_1_Wait_for_succ;
	when ((true) && (inToken_1==2)) may outToken_1=inToken_1; goto Candidate_1_Wait_for_succ;
	when ((true) && (inToken_1==3)) may outToken_1=inToken_1; goto Candidate_1_Wait_for_succ;
	when ((true) && (inToken_1==4)) may outToken_1=inToken_1; goto Candidate_1_Wait_for_succ;
}

mode Candidate_1_Wait_for_succ (true) {
	when !set_lock_1 ((true) && (true)) may x2 = 0; goto Candidate_1_Wait_till_succ_read_outToken;
}

mode Candidate_1_Wait_till_succ_read_outToken (true) {
	when !release_lock_1 ((true) && (true)) may x1 = 0; goto Candidate_1_Wait_for_pre;
}

mode Candidate_1_Leader (true) {
}


/****** COMPONENT: Candidate_2 *****/
mode Candidate_2_Init (x2<=0) {
	when ?set_lock_1 ((true) && (true)) may x2 = 0; goto Candidate_2_Read_inToken;
	when !set_lock_2 ((true) && (true)) may x3 = 0; goto Candidate_2_Wait_till_succ_read_outToken;
}

mode Candidate_2_Wait_for_pre (x2<=0) {
	when ?set_lock_1 ((true) && (true)) may x2 = 0; goto Candidate_2_Read_inToken;
}

mode Candidate_2_Read_inToken (x2<=1) {
	when ((true) && (true)) may inToken_2=outToken_1; goto Candidate_2_Release_in_lock;
}

mode Candidate_2_Release_in_lock (x2<=1) {
	when ?release_lock_1 ((true) && (true)) may x1 = 0; goto Candidate_2_Eval_inToken;
}

mode Candidate_2_Eval_inToken (x2<=1) {
	when ?finished_2 ((true) && (inToken_2==2)) may goto Candidate_2_Leader;
	when ((true) && (inToken_2==0)) may goto Candidate_2_Wait_for_succ;
	when ((true) && (inToken_2==1)) may goto Candidate_2_Wait_for_succ;
	when ((true) && (inToken_2==3)) may outToken_2=inToken_2; goto Candidate_2_Wait_for_succ;
	when ((true) && (inToken_2==4)) may outToken_2=inToken_2; goto Candidate_2_Wait_for_succ;
}

mode Candidate_2_Wait_for_succ (true) {
	when !set_lock_2 ((true) && (true)) may x3 = 0; goto Candidate_2_Wait_till_succ_read_outToken;
}

mode Candidate_2_Wait_till_succ_read_outToken (true) {
	when !release_lock_2 ((true) && (true)) may x2 = 0; goto Candidate_2_Wait_for_pre;
}

mode Candidate_2_Leader (true) {
}


/****** COMPONENT: Candidate_3 *****/
mode Candidate_3_Init (x3<=0) {
	when ?set_lock_2 ((true) && (true)) may x3 = 0; goto Candidate_3_Read_inToken;
	when !set_lock_3 ((true) && (true)) may x4 = 0; goto Candidate_3_Wait_till_succ_read_outToken;
}

mode Candidate_3_Wait_for_pre (x3<=0) {
	when ?set_lock_2 ((true) && (true)) may x3 = 0; goto Candidate_3_Read_inToken;
}

mode Candidate_3_Read_inToken (x3<=1) {
	when ((true) && (true)) may inToken_3=outToken_2; goto Candidate_3_Release_in_lock;
}

mode Candidate_3_Release_in_lock (x3<=1) {
	when ?release_lock_2 ((true) && (true)) may x2 = 0; goto Candidate_3_Eval_inToken;
}

mode Candidate_3_Eval_inToken (x3<=1) {
	when ?finished_3 ((true) && (inToken_3==3)) may goto Candidate_3_Leader;
	when ((true) && (inToken_3==0)) may goto Candidate_3_Wait_for_succ;
	when ((true) && (inToken_3==1)) may goto Candidate_3_Wait_for_succ;
	when ((true) && (inToken_3==2)) may goto Candidate_3_Wait_for_succ;
	when ((true) && (inToken_3==4)) may outToken_3=inToken_3; goto Candidate_3_Wait_for_succ;
}

mode Candidate_3_Wait_for_succ (true) {
	when !set_lock_3 ((true) && (true)) may x4 = 0; goto Candidate_3_Wait_till_succ_read_outToken;
}

mode Candidate_3_Wait_till_succ_read_outToken (true) {
	when !release_lock_3 ((true) && (true)) may x3 = 0; goto Candidate_3_Wait_for_pre;
}

mode Candidate_3_Leader (true) {
}


/****** COMPONENT: Candidate_4 *****/
mode Candidate_4_Init (x4<=0) {
	when ?set_lock_3 ((true) && (true)) may x4 = 0; goto Candidate_4_Read_inToken;
	when ?set_lock_4 ((true) && (true)) may x0 = 0; goto Candidate_4_Wait_till_succ_read_outToken;
}

mode Candidate_4_Wait_for_pre (x4<=0) {
	when ?set_lock_3 ((true) && (true)) may x4 = 0; goto Candidate_4_Read_inToken;
}

mode Candidate_4_Read_inToken (x4<=1) {
	when ((true) && (true)) may inToken_4=outToken_3; goto Candidate_4_Release_in_lock;
}

mode Candidate_4_Release_in_lock (x4<=1) {
	when ?release_lock_3 ((true) && (true)) may x3 = 0; goto Candidate_4_Eval_inToken;
}

mode Candidate_4_Eval_inToken (x4<=1) {
	when ?finished_4 ((true) && (inToken_4==4)) may goto Candidate_4_Leader;
	when ((true) && (inToken_4==0)) may goto Candidate_4_Wait_for_succ;
	when ((true) && (inToken_4==1)) may goto Candidate_4_Wait_for_succ;
	when ((true) && (inToken_4==2)) may goto Candidate_4_Wait_for_succ;
	when ((true) && (inToken_4==3)) may goto Candidate_4_Wait_for_succ;
}

mode Candidate_4_Wait_for_succ (true) {
	when ?set_lock_4 ((true) && (true)) may x0 = 0; goto Candidate_4_Wait_till_succ_read_outToken;
}

mode Candidate_4_Wait_till_succ_read_outToken (true) {
	when ?release_lock_4 ((true) && (true)) may x4 = 0; goto Candidate_4_Wait_for_pre;
}

mode Candidate_4_Leader (true) {
}


initially
	Stopwatch_Wait_for_Leader@(1)
	and Candidate_0_Init@(2)
	and Candidate_1_Init@(3)
	and Candidate_2_Init@(4)
	and Candidate_3_Init@(5)
	and Candidate_4_Init@(6)
	and timer == 0
	and x0 == 0
	and x1 == 0
	and x2 == 0
	and x3 == 0
	and x4 == 0
	and inToken_0 == 0
	and inToken_1 == 1
	and inToken_2 == 2
	and inToken_3 == 3
	and inToken_4 == 4
	and outToken_0 == 0
	and outToken_1 == 1
	and outToken_2 == 2
	and outToken_3 == 3
	and outToken_4 == 4
;
